SystemOrganization addCategory: #'GMF-DataManager'!

Object subclass: #DataModel
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-DataManager'!

!DataModel class methodsFor: 'instance creation' stamp: 'RostislavNovk 10/28/2013 21:08'!
new
	^ super new
		initialize;
		yourself! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:29'!
add: dataClass
	elements add: dataClass.! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:29'!
asMetaModel
	| metaModel |
	metaModel := MetaModel new.
	elements do: [ :e | metaModel addElement: (e metaModelClass)  ].
	^metaModel.
	! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovk 10/28/2013 21:05'!
elements
	^elements copy.! !

!DataModel methodsFor: 'initialize-release' stamp: 'RostislavNovk 10/28/2013 21:05'!
initialize
	elements := OrderedCollection new.! !

!DataModel methodsFor: 'accessing' stamp: 'LukasKoc 12/1/2013 19:33'!
loadFile

	"comment stating purpose of message"


	! !

!DataModel methodsFor: 'accessing' stamp: 'RostislavNovak 11/27/2013 23:20'!
remove: dataClass
	elements remove: dataClass.! !

!DataModel methodsFor: 'accessing' stamp: 'LukasKoc 12/5/2013 21:00'!
saveClass: Class to: file
	| xx yy w h attrib type nam |
	attrib := OrderedCollection new.
	file isClass: 1.
	xx := ((Class positionClass) leftTopPoint ) x .
	yy := ((Class positionClass) leftTopPoint ) y .
	w := (((Class positionClass) rightBottomPoint ) x) - xx.
	h := (((Class positionClass) rightBottomPoint ) y) - yy.
	file saveX: xx  Y: yy .
	file saveW: w H: h .
	type := (Class metaModelClass ) className. 
	nam :=  (Class metaModelClass ) name.
	attrib add: 'bg=light_gray'.
	attrib add: '&lt;&lt;',type,'&gt;&gt; '.
	attrib add: '*',nam,'*'.
	attrib add: '--'.
	(Class metaModelClass ) attributs do:[ :a | attrib add: a ].
	attrib add: '--'.
	(Class metaModelClass ) methods do:[ :a | attrib add: a ].
	file addAttributes: attrib.
	attrib removeAll.! !

!DataModel methodsFor: 'accessing' stamp: 'LukasKoc 12/5/2013 20:54'!
saveFile
	"comment stating purpose of message"

	| file type |
	file := FileManip new.
	file preparationForSave.
	elements do:[ :e |
		type := (e metaModelClass ).
		(type isClass)
		 ifTrue: [ file isC: 1. (self saveClass: e to: file ) ]
		 ifFalse: [ file isC: 0. (self saveRelation: e to: file ) ].
		].

	file finishFile.! !

!DataModel methodsFor: 'accessing' stamp: 'LukasKoc 12/5/2013 21:15'!
saveRelation: Relation to: file 

	| xx yy w h attrib type addattrib |
	attrib := OrderedCollection new.
	addattrib := OrderedCollection new.
	file isClass: 0.
	type := (Relation positionClass ) className.
	(type = 'PositionGroupOfLines')  "checking if the Relation is made by more than 1 line"
	ifTrue: [
		xx := ((((Relation positionClass) lines) at: 1) start ) x. "reference point  = start of the first line"
		yy := ((((Relation positionClass) lines) at: 1) start ) y. "reference point  = start of the first line"
		addattrib add: 0. "destination - start"
		addattrib add: 0.
		((Relation positionClass) lines) do:[
			:line | 
			addattrib add: (((line end) x) - xx). "destination - start"
			addattrib add: (((line end) y) - yy). "destination - start"
			]
	]
	ifFalse: [
			xx := ((Relation positionClass)  start ) x.
			yy := ((Relation positionClass)  start ) y.
			addattrib add: 0. "destination - start"
			addattrib add: 0.
			addattrib add: ((((Relation positionClass)  end ) x) - xx). "destination - start"
			addattrib add: ((((Relation positionClass)  end ) y) - yy). "destination - start"
	].

	"this can be changed to dependency on type of Relation"
	type := 'lt=-'.
	attrib add: type.
	attrib add: ('m1=',((Relation metaModelClass) startQuantity)) .
	attrib add: ('m2=',((Relation metaModelClass) endQuantity)) .
	attrib add: ((Relation metaModelClass) name) .
	w := 10.
	h := 10.
	file saveX: xx Y: yy.
	file saveW: w H: h.
	file addAttributes: attrib .
	file addPAttributes: addattrib .
	


! !

Object subclass: #FileManip
	instanceVariableNames: 'name working isC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-DataManager'!

!FileManip class methodsFor: 'instance creation' stamp: 'LukasKoc 11/29/2013 23:40'!
name: name

	^ self new
		name: name;
		yourself! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 17:18'!
addAttributes: attCollection
	"Adding additional_attributes part into .uxf file."

	| stream |
	stream := name writeStream.
	stream setToEnd .
	stream nextPutAll: Character cr asString, '<panel_attributes>'.
	attCollection do: [ :n | stream nextPutAll: n asString, Character cr asString ].
	stream nextPutAll: '</panel_attributes>'.
	(isC) ifTrue: [ stream nextPutAll: Character cr asString, '<additional_attributes/>', Character cr asString, '</element>' ].
	stream close.! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 19:18'!
addPAttributes: attCollection
	
	"This method is very similar to addAttributes, but its made for reators."
	|stream|
	stream := name writeStream.
	stream setToEnd .
	stream nextPutAll: Character cr asString, '<additional_attributes>'.
	attCollection do: [ :n | stream nextPutAll: n asString, ';' ].
	stream skip: -1.
	stream nextPutAll: '</additional_attributes>'.
	stream nextPutAll: Character cr asString, '</element>'.
	stream close.! !

!FileManip methodsFor: 'initialize-release' stamp: 'LukasKoc 11/30/2013 15:05'!
finishFile

	"This function add last line into .uxf file. Then its ready to preview e. g. in UMLet."

	| s1 s2 |
	s1 := ( working / 'GMF-data' / 'end.txt' ) readStream.
	s2 := ( name ) writeStream.
	s2 setToEnd  .
	s2 nextPutAll: Character cr asString. 
	s2 nextPutAll:  s1.
	s1 close.
	s2 close.! !

!FileManip methodsFor: 'initialize-release' stamp: 'LukasKoc 11/30/2013 17:06'!
initialize
	"Setting the filename and deleting it if it extist. Its possible to adjust this code to create the different file and let the original 	be still valid."

	super initialize.
	working := FileSystem disk workingDirectory.
	isC := true.
	name := working / 'save-file.uxf' .
	(name isFile) ifTrue: [name delete] .! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 16:52'!
isC
	
	^ isC! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 16:52'!
isC: anObject
	
	isC := anObject! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 17:06'!
isClass: b
	"Checking if current element is class or relation so specific type could be set."
	| s1 s2 |
	
 	
	s2 := ( name ) writeStream.
	( b == 1 )
	ifTrue: [ s1 := (working / 'GMF-data' / 'class.txt') readStream. isC := true ]
	ifFalse: [ s1 := (working / 'GMF-data' / 'relation.txt') readStream. isC := false ].
	s2 setToEnd  .
	s2 nextPutAll: Character cr asString. 
	s2 nextPutAll:  s1.	
	s1 close.
	s2 close.! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/29/2013 23:50'!
name

	^ name! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/29/2013 23:40'!
name: anObject
	
	name := anObject! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 14:54'!
preparationForSave
	"comment stating purpose of message"

	"| stream|
	stream := name writeStream.
	stream nextPutAll: 'start'.
	"
	| s1 s2 |
	s1 := (working / 'GMF-data' / 'init.txt') readStream.
	s2 := ( name ) writeStream.
	s2 nextPutAll: s1.
	"s2 nextPutAll: Character cr asString, 'yolo'."
	s1 close.
	s2 close.
	! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 16:13'!
saveW: w H: h
	"comment stating purpose of message"

	| stream |
	stream := name writeStream.
	stream setToEnd.
	stream nextPutAll:  Character cr asString, '<w>', w asString, '</w>',  Character cr asString, '<h>', h asString, '</h>' . 
	stream nextPutAll: Character cr asString, '</coordinates>'.
	stream close.! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/30/2013 16:10'!
saveX: x Y: y
	"comment stating purpose of message"

	| stream |
	stream := name writeStream.
	stream setToEnd.
	stream nextPutAll:  Character cr asString, '<x>', x asString, '</x>',  Character cr asString, '<y>', y asString, '</y>' . 
	stream close.! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/29/2013 23:49'!
working
	
	^ working! !

!FileManip methodsFor: 'accessing' stamp: 'LukasKoc 11/29/2013 23:49'!
working: anObject
	
	working := anObject! !

Object subclass: #FileManipLoad
	instanceVariableNames: 'addAttributes attributes coordinates file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-DataManager'!

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
addAttributes
	
	^ addAttributes! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
addAttributes: anObject
	
	addAttributes := anObject! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
attributes
	
	^ attributes! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
attributes: anObject
	
	attributes := anObject! !

!FileManipLoad methodsFor: 'terminate' stamp: 'LukasKoc 12/3/2013 17:20'!
closeFile
	file close.! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
coordinates
	
	^ coordinates! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
coordinates: anObject
	
	coordinates := anObject! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
file
	
	^ file! !

!FileManipLoad methodsFor: 'accessing' stamp: 'LukasKoc 12/3/2013 17:19'!
file: anObject
	
	file := anObject! !

!FileManipLoad methodsFor: 'initialize' stamp: 'LukasKoc 12/3/2013 17:19'!
initialize
	"Initialization code for FileManipLoad"
	|workdir |
	super initialize.
	workdir := FileSystem disk workingDirectory.
	addAttributes := OrderedCollection new.
	attributes := OrderedCollection new.
	coordinates := OrderedCollection new.
	file := ( workdir / 'load-file.uxf') readStream.! !
